
@article{jelasity_gossip-based_2007,
	title = {Gossip-based Peer Sampling},
	volume = {25},
	issn = {0734-2071},
	url = {http://doi.acm.org/10.1145/1275517.1275520},
	doi = {10.1145/1275517.1275520},
	number = {3},
	journaltitle = {{ACM} Trans. Comput. Syst.},
	author = {Jelasity, Márk and Voulgaris, Spyros and Guerraoui, Rachid and Kermarrec, Anne-Marie and van Steen, Maarten},
	date = {2007-08},
	keywords = {epidemic protocols, Gossip-based protocols, peer sampling service}
}

@inproceedings{matos_epto:_2015,
	location = {New York, {NY}, {USA}},
	title = {{EpTO}: An Epidemic Total Order Algorithm for Large-Scale Distributed Systems},
	isbn = {978-1-4503-3618-5},
	url = {http://doi.acm.org/10.1145/2814576.2814804},
	doi = {10.1145/2814576.2814804},
	series = {Middleware '15},
	pages = {100--111},
	booktitle = {Proceedings of the 16th Annual Middleware Conference},
	publisher = {{ACM}},
	author = {Matos, Miguel and Mercier, Hugues and Felber, Pascal and Oliveira, Rui and Pereira, José},
	date = {2015},
	keywords = {data dissemination, epidemic algorithm, large-scale distributed systems, order, total}
}

@article{nedelec_adaptive_2017,
	title = {An Adaptive Peer-Sampling Protocol for Building Networks of Browsers},
	volume = {25},
	url = {https://hal.inria.fr/hal-01619906},
	doi = {10.1007/s11280-017-0478-5},
	pages = {1678},
	journaltitle = {World Wide Web},
	author = {Nédelec, Brice and Tanke, Julian and Molli, Pascal and Mostefaoui, Achour and Frey, Davide},
	date = {2017}
}

@inproceedings{allard_lightweight_2016,
	location = {Trento, Italy},
	title = {Lightweight Privacy-Preserving Averaging for the Internet of Things},
	url = {https://hal.inria.fr/hal-01421986},
	doi = {10.1145/3008631.3008635},
	pages = {19 -- 22},
	booktitle = {M4IOT 2016 - 3rd Workshop on Middleware for Context-Aware Applications in the {IoT}},
	publisher = {{ACM}},
	author = {Allard, Tristan and Frey, Davide and Giakkoupis, George and Lepiller, Julien},
	date = {2016-12}
}

@article{defago_total_2004,
	title = {Total order broadcast and multicast algorithms: Taxonomy and survey},
	volume = {36},
	pages = {372--421},
	number = {4},
	journaltitle = {{ACM} Computing Surveys ({CSUR})},
	author = {Défago, Xavier and Schiper, André and Urbán, Péter},
	date = {2004}
}

@article{lamport_time_1978,
	title = {Time, clocks, and the ordering of events in a distributed system},
	volume = {21},
	pages = {558--565},
	number = {7},
	journaltitle = {Communications of the {ACM}},
	author = {Lamport, Leslie},
	date = {1978}
}

@report{nedelec_spray:_2015,
	title = {Spray: an Adaptive Random Peer Sampling Protocol},
	url = {https://hal.archives-ouvertes.fr/hal-01203363},
	institution = {{LINA}-University of Nantes ; {INRIA} Rennes - Bretagne Atlantique},
	type = {Technical Report},
	author = {Nédelec, Brice and Tanke, Julian and Frey, Davide and Molli, Pascal and Mostefaoui, Achour},
	date = {2015-09}
}

@article{deb_algebraic_2006,
	title = {Algebraic gossip: A network coding approach to optimal multiple rumor mongering},
	volume = {14},
	pages = {2486--2507},
	issue = {{SI}},
	journaltitle = {{IEEE}/{ACM} Transactions on Networking ({TON})},
	author = {Deb, Supratim and Médard, Muriel and Choute, Clifford},
	date = {2006}
}

@inproceedings{haeupler_analyzing_2011,
	title = {Analyzing network coding gossip made easy},
	pages = {293--302},
	booktitle = {Proceedings of the forty-third annual {ACM} symposium on Theory of computing},
	publisher = {{ACM}},
	author = {Haeupler, Bernhard},
	date = {2011}
}

@inproceedings{mosk-aoyama_information_2006,
	title = {Information dissemination via network coding},
	pages = {1748--1752},
	booktitle = {Information Theory, 2006 {IEEE} International Symposium on},
	publisher = {{IEEE}},
	author = {Mosk-Aoyama, Damon and Shah, Devavrat},
	date = {2006}
}

@article{li_linear_2003,
	title = {Linear network coding},
	volume = {49},
	issn = {0018-9448},
	doi = {10.1109/TIT.2002.807285},
	pages = {371--381},
	number = {2},
	journaltitle = {{IEEE} Transactions on Information Theory},
	author = {Li, S. Y. R. and Yeung, R. W. and Cai, Ning},
	date = {2003-02},
	keywords = {acyclic network, Channel capacity, communication network, Communication networks, Communication switching, Conferences, directed graphs, directed multigraph, information rate, Information rates, Information theory, linear codes, linear network coding, linear transformation, max-flow bound, multicast communication, multicast mechanisms optimization, Network coding, network nodes, network routing, Routing, source nodes multicast information, Spread spectrum communication, telecommunication network routing, vector, Vectors}
}

@inproceedings{bertier_d2ht:_2010,
	title = {D2HT: the best of both worlds, Integrating {RPS} and {DHT}},
	pages = {135--144},
	booktitle = {Dependable Computing Conference ({EDCC}), 2010 European},
	publisher = {{IEEE}},
	author = {Bertier, Marin and Bonnet, François and Kermarrec, Anne-Marie and Leroy, Vincent and Peri, Sathya and Raynal, Michel},
	date = {2010}
}

@article{jelasity_gossip-based_2005,
	title = {Gossip-based Aggregation in Large Dynamic Networks},
	volume = {23},
	issn = {0734-2071},
	url = {http://doi.acm.org/10.1145/1082469.1082470},
	doi = {10.1145/1082469.1082470},
	pages = {219--252},
	number = {3},
	journaltitle = {{ACM} Trans. Comput. Syst.},
	author = {Jelasity, Márk and Montresor, Alberto and Babaoglu, Ozalp},
	date = {2005-08},
	keywords = {Gossip-based protocols, proactive aggregation}
}

@article{bortnikov_brahms:_2009,
	title = {Brahms: Byzantine Resilient Random Membership Sampling},
	volume = {53},
	issn = {1389-1286},
	url = {http://dx.doi.org/10.1016/j.comnet.2009.03.008},
	doi = {10.1016/j.comnet.2009.03.008},
	pages = {2340--2359},
	number = {13},
	journaltitle = {Comput. Netw.},
	author = {Bortnikov, Edward and Gurevich, Maxim and Keidar, Idit and Kliot, Gabriel and Shraer, Alexander},
	date = {2009-08},
	keywords = {Byzantine faults, Gossip, Membership, Random sampling}
}

@online{_time_????,
	title = {Time and order},
	url = {http://book.mixu.net/distsys/time.html}
}

@article{georgiou_meeting_2011,
	title = {Meeting the deadline: on the complexity of fault-tolerant continuous gossip},
	volume = {24},
	pages = {223--244},
	number = {5},
	journaltitle = {Distributed Computing},
	author = {Georgiou, Chryssis and Gilbert, Seth and Kowalski, Dariusz R},
	date = {2011}
}

@inproceedings{demers_epidemic_1987,
	location = {New York, {NY}, {USA}},
	title = {Epidemic Algorithms for Replicated Database Maintenance},
	isbn = {0-89791-239-X},
	url = {http://doi.acm.org/10.1145/41840.41841},
	doi = {10.1145/41840.41841},
	series = {{PODC} '87},
	pages = {1--12},
	booktitle = {Proceedings of the Sixth Annual {ACM} Symposium on Principles of Distributed Computing},
	publisher = {{ACM}},
	author = {Demers, Alan and Greene, Dan and Hauser, Carl and Irish, Wes and Larson, John and Shenker, Scott and Sturgis, Howard and Swinehart, Dan and Terry, Doug},
	date = {1987}
}

@inproceedings{kempe_spatial_2001,
	location = {New York, {NY}, {USA}},
	title = {Spatial Gossip and Resource Location Protocols},
	isbn = {1-58113-349-9},
	url = {http://doi.acm.org/10.1145/380752.380796},
	doi = {10.1145/380752.380796},
	series = {{STOC} '01},
	pages = {163--172},
	booktitle = {Proceedings of the Thirty-third Annual {ACM} Symposium on Theory of Computing},
	publisher = {{ACM}},
	author = {Kempe, David and Kleinberg, Jon and Demers, Alan},
	date = {2001},
	keywords = {qdu\_spatial, qdu\_videogame}
}

@inproceedings{kempe_protocols_2002,
	title = {Protocols and impossibility results for gossip-based communication mechanisms},
	doi = {10.1109/SFCS.2002.1181971},
	abstract = {In recent years, gossip-based algorithms have gained prominence as a methodology for designing robust and scalable communication schemes in large distributed systems. The premise underlying distributed gossip is very simple: in each time step, each node v in the system selects some other node w as a communication partner, generally by a simple randomized rule, and exchanges information with w; over a period of time, information spreads through the system in an "epidemic fashion". A fundamental issue which is not well understood is the following: how does the underlying low-level gossip mechanism (the means by which communication partners are chosen) affect one's ability to design efficient high-level gossip-based protocols? We establish one of the first concrete results addressing this question, by showing a fundamental limitation on the power of the commonly used uniform gossip mechanism for solving nearest-resource location problems. In contrast, very efficient protocols for this problem can be designed using a non-uniform spatial gossip mechanism, as established in earlier work with Alan Demers. We go on to consider the design of protocols for more complex problems, providing an efficient distributed gossip-based protocol for a set of nodes in Euclidean space to construct an approximate minimum spanning tree. Here too, we establish a contrasting limitation on the power of uniform gossip for solving this problem. Finally, we investigate gossip-based packet routing as a primitive that underpins the communication patterns in many protocols, and as a way to understand the capabilities of different gossip mechanisms at a general level.},
	pages = {471--480},
	booktitle = {The 43rd Annual {IEEE} Symposium on Foundations of Computer Science, 2002. Proceedings.},
	author = {Kempe, D. and Kleinberg, J.},
	date = {2002},
	keywords = {Aggregates, Algorithm design and analysis, Career development, Computer science, Concrete, Context, Design methodology, Euclidean space, Fault tolerance, gossip-based algorithms, gossip-based communication mechanisms, high-level gossip-based protocols, impossibility results, large distributed systems, low-level gossip mechanism, message passing, robust scalable communication schemes, Robustness, Routing protocols, transport protocols, qdu\_spatial, qdu\_videogame}
}

@inproceedings{ho_benefits_2003,
	title = {The benefits of coding over routing in a randomized setting},
	doi = {10.1109/ISIT.2003.1228459},
	abstract = {A novel randomized network coding approach for robust, distributed transmission and compression of information in networks is presented, and its advantages over routing-based approaches is demonstrated.},
	pages = {442--},
	booktitle = {{IEEE} International Symposium on Information Theory, 2003. Proceedings.},
	author = {Ho, T. and Koetter, R. and Medard, M. and Karger, D. R. and Effros, M.},
	date = {2003-06},
	keywords = {multicast communication, Network coding, Routing, telecommunication network routing, Vectors, Robustness, Decoding, distributed transmission, Electronic mail, Galois fields, information networks, network topology, Polynomials, random codes, randomized network coding, Signal processing, Upper bound}
}

@inproceedings{ho_randomized_2003,
	title = {On randomized network coding},
	volume = {41},
	pages = {11--20},
	booktitle = {Proceedings of the Annual Allerton Conference on Communication Control and Computing},
	publisher = {The University; 1998},
	author = {Ho, Tracey and Medard, Muriel and Shi, Jun and Effros, Michelle and Karger, David R},
	date = {2003}
}

@inproceedings{chou_practical_2003,
	title = {Practical Network Coding},
	url = {https://www.microsoft.com/en-us/research/publication/practical-network-coding-2/},
	abstract = {We propose a distributed scheme for practical network coding that obviates the need for centralized knowledge of the graph topology, the encoding functions, and the decoding functions, and furthermore obviates the need for information to be communicated synchronously through the network. The result is a practical system for networking coding that is robust to random packet loss and delay as well as robust to any changes in the network topology or capacity due to joins, leaves, node or link failures, congestion, and so on. We simulate such a practical network coding system using the network topologies of several commercial Internet Service Providers, and demonstrate that it can achieve close to the theoretically optimal performance.},
	booktitle = {Allerton Conference on Communication, Control, and Computing},
	author = {Chou, Philip A. and Wu, Yunnan and Jain, Kamal},
	date = {2003-10}
}

@article{fragouli_network_2006,
	title = {Network Coding: An Instant Primer},
	volume = {36},
	issn = {0146-4833},
	url = {http://doi.acm.org/10.1145/1111322.1111337},
	doi = {10.1145/1111322.1111337},
	pages = {63--68},
	number = {1},
	journaltitle = {{SIGCOMM} Comput. Commun. Rev.},
	author = {Fragouli, Christina and Le Boudec, Jean-Yves and Widmer, Jörg},
	date = {2006-01},
	keywords = {network coding}
}

@online{karonen_galois_????,
	title = {Galois fields in cryptography},
	url = {https://crypto.stackexchange.com/a/2718},
	author = {Karonen, Ilmari}
}

@book{wagner_laws_????,
	title = {The Laws of Cryptography with Java Code},
	url = {http://www.cs.utsa.edu/~wagner/lawsbookcolor/laws.pdf},
	author = {Wagner, Neal}
}

@inproceedings{haeupler_faster_2011,
	location = {New York, {NY}, {USA}},
	title = {Faster Information Dissemination in Dynamic Networks via Network Coding},
	isbn = {978-1-4503-0719-2},
	url = {http://doi.acm.org/10.1145/1993806.1993885},
	doi = {10.1145/1993806.1993885},
	series = {{PODC} '11},
	pages = {381--390},
	booktitle = {Proceedings of the 30th Annual {ACM} {SIGACT}-{SIGOPS} Symposium on Principles of Distributed Computing},
	publisher = {{ACM}},
	author = {Haeupler, Bernhard and Karger, David},
	date = {2011},
	keywords = {network coding, dynamic networks, gossip, multicast}
}

@article{li_random_2011,
	title = {Random Network Coding in Peer-to-Peer Networks: From Theory to Practice},
	volume = {99},
	issn = {0018-9219},
	doi = {10.1109/JPROC.2010.2091930},
	abstract = {With random network coding, network nodes between the source and receivers are able to not only relay and replicate data packets, but also code them using randomly generated coding coefficients. From a theoretical perspective, it has been recognized that network coding maximizes the network flow rates in multicast sessions in directed acyclic network graphs. To date, random network coding has seen practical and real-world applications in peer-to-peer (P2P) networks, in which overlay network topologies are formed among participating end hosts, called “peers.” Due to uncertainties and dynamics involved with peer arrivals and departures, these network topologies are usually randomly generated in practice, and are referred to as “random mesh” topologies. Unlike structured topologies such as trees, random mesh topologies are practical to be implemented, and are resilient to the level of volatility typically experienced in peer-to-peer networks. It has been shown, from both theoretical and practical perspectives, that random network coding leads to performance benefits in these peer-to-peer networks with random mesh topologies. This paper presents a survey of existing results with respect to practical applications of random network coding in peer-to-peer networks. We focus on bulk content distribution and media streaming systems, as well as the computational overhead introduced by random network coding in modern off-the-shelf servers and mobile devices. Throughout the paper, we also show theoretical insights on why random network coding may become beneficial in practice.},
	pages = {513--523},
	number = {3},
	journaltitle = {Proceedings of the {IEEE}},
	author = {Li, B. and Niu, D.},
	date = {2011-03},
	keywords = {directed graphs, Network coding, network coding, bulk content distribution, coding coefficients, Content distribution, directed acyclic network graphs, Encoding, media streaming, media streaming systems, mobile devices, multicast sessions, Network topology, overlay network topology, Peer to peer computing, peer-to-peer (P2P) networks, peer-to-peer computing, peer-to-peer networks, random gossip, random mesh topology, random network coding, randomized algorithms, Receivers, Telecommunication network management, Topology}
}

@inproceedings{champel_fog:_2009,
	title = {{FoG}: Fighting the Achilles' Heel of Gossip Protocols with Fountain Codes},
	url = {https://doi.org/10.1007/978-3-642-05118-0_13},
	doi = {10.1007/978-3-642-05118-0_13},
	pages = {180--194},
	booktitle = {Stabilization, Safety, and Security of Distributed Systems, 11th International Symposium, {SSS} 2009, Lyon, France, November 3-6, 2009. Proceedings},
	author = {Champel, Mary-Luc and Kermarrec, Anne-Marie and Scouarnec, Nicolas Le},
	date = {2009}
}

@inproceedings{champel_lt_2010,
	title = {{LT} Network Codes},
	url = {https://doi.org/10.1109/ICDCS.2010.14},
	doi = {10.1109/ICDCS.2010.14},
	pages = {536--546},
	booktitle = {2010 International Conference on Distributed Computing Systems, {ICDCS} 2010, Genova, Italy, June 21-25, 2010},
	author = {Champel, Mary-Luc and Huguenin, Kévin and Kermarrec, Anne-Marie and Scouarnec, Nicolas Le},
	date = {2010}
}

@article{ho_random_2006,
	title = {A random linear network coding approach to multicast},
	volume = {52},
	pages = {4413--4430},
	number = {10},
	journaltitle = {{IEEE} Transactions on Information Theory},
	author = {Ho, Tracey and Médard, Muriel and Koetter, Ralf and Karger, David R and Effros, Michelle and Shi, Jun and Leong, Ben},
	date = {2006}
}

@inreference{_palette_????,
	title = {Palette Apprentissage automatique},
	url = {https://fr.wikipedia.org/wiki/Mod%C3%A8le:Palette_Apprentissage_automatique}
}

@article{avin_order_2013,
	title = {Order optimal information spreading using algebraic gossip},
	volume = {26},
	pages = {99--117},
	number = {2},
	journaltitle = {Distributed computing},
	author = {Avin, Chen and Borokhovich, Michael and Censor-Hillel, Keren and Lotker, Zvi},
	date = {2013}
}

@article{felber_pulp:_2012,
	title = {Pulp: An adaptive gossip-based dissemination protocol for multi-source message streams},
	volume = {5},
	pages = {74--91},
	number = {1},
	journaltitle = {Peer-to-Peer Networking and Applications},
	author = {Felber, Pascal and Kermarrec, Anne-Marie and Leonini, Lorenzo and Riviere, Etienne and Voulgaris, Spyros},
	date = {2012}
}

@inproceedings{wu_constructive_2006,
	title = {On Constructive Multi-Source Network Coding},
	doi = {10.1109/ISIT.2006.262046},
	abstract = {The multi-source network coding problem, where multiple multicast sessions with independent data share a network, is an open challenge. It is observed that random mixing is asymptotically optimal for a pollution-free multi-source network coding problem, where no receiver can be reached by a source it does not need. To handle pollution in a general network, a pollution-free network of tagged pipes is constructed. Each link is partitioned into tagged pipes; each tag is a subset of the sources. The content flowing in each pipe can only be a function of the sources indicated in the tag. The pipes are interconnected to form a pollution-free network. This constructive scheme gives rise to an achievability theorem for general multi-source network coding. For acyclic graphs, the fact that decoded information can be used in generating output is modelled via "helpers". This results in a stronger achievability theorem for acyclic graphs. Further incorporating the degree of freedom in adding receivers, an even stronger achievability theorem is derived},
	pages = {1349--1353},
	booktitle = {2006 {IEEE} International Symposium on Information Theory},
	author = {Wu, Y.},
	date = {2006-07},
	keywords = {multicast communication, Network coding, Vectors, Decoding, achievability theorem, acyclic graphs, Capacity planning, Constraint theory, constructive multi-source network coding, graph theory, independent network data sharing, multiple multicast sessions, Pollution, pollution-free multi-source network coding problem, random mixing, source coding, tagged pipes, Telecommunication traffic, Traffic control, Unicast}
}

@article{liu_network_2016,
	title = {Network coding-based multisource content delivery in Content Centric Networking},
	volume = {64},
	issn = {1084-8045},
	url = {http://www.sciencedirect.com/science/article/pii/S1084804516000813},
	doi = {https://doi.org/10.1016/j.jnca.2016.02.007},
	abstract = {Abstract Content Centric Networking ({CCN}) is a new network architecture around content dissemination and retrieval. Its request–response and in-network caching mechanisms can significantly improve the network performance in reducing the transmission delay. However, the in-network caching may prevent the network coding technique from being applied into {CCN} because cached coded blocks may not be linearly independent to each other such that they cannot be used for responding the future requests. In this paper, we propose a novel request-specified network coding ({RSNC}) scheme for efficiently encoding and delivering chunks of content. In this scheme, a new Interest coding and forwarding strategy is proposed for specifying network coding requirements and getting linearly independent coded blocks simultaneously from multiple nodes. Our simulation results show that the proposed scheme achieves better performance than conventional {CCN} in terms of average download time, cache hit ratio, and transmission amount.},
	pages = {167 -- 175},
	journaltitle = {Journal of Network and Computer Applications},
	author = {Liu, Yan and Yu, Shun-Zheng},
	date = {2016},
	keywords = {Network coding, Content Centric Networking, Multisource content delivery}
}

@article{defago_total_2004-1,
	title = {Total Order Broadcast and Multicast Algorithms: Taxonomy and Survey},
	volume = {36},
	issn = {0360-0300},
	url = {http://doi.acm.org/10.1145/1041680.1041682},
	doi = {10.1145/1041680.1041682},
	pages = {372--421},
	number = {4},
	journaltitle = {{ACM} Comput. Surv.},
	author = {Défago, Xavier and Schiper, André and Urbán, Péter},
	date = {2004-12},
	keywords = {message passing, agreement problems, atomic broadcast, atomic multicast, classification, distributed algorithms, Distributed systems, fault-tolerance, global ordering, group communication, survey, taxonomy, total ordering}
}

@article{mattern_virtual_1989,
	title = {Virtual time and global states of distributed systems},
	volume = {1},
	pages = {215--226},
	number = {23},
	journaltitle = {Parallel and Distributed Algorithms},
	author = {Mattern, Friedemann and {others}},
	date = {1989},
	keywords = {clock vector}
}

@article{fidge_timestamps_1988,
	title = {Timestamps in message-passing systems that preserve the partial ordering},
	volume = {10},
	url = {http://sky.scitech.qut.edu.au/ fidgec/Publications/fidge88a.pdf},
	pages = {56--66},
	number = {1},
	journaltitle = {Proceedings of the 11th Australian Computer Science Conference},
	author = {Fidge, C. J.},
	date = {1988},
	keywords = {clock vector}
}

@article{chandy_distributed_1985,
	title = {Distributed snapshots: Determining global states of distributed systems},
	volume = {3},
	pages = {63--75},
	number = {1},
	journaltitle = {{ACM} Transactions on Computer Systems ({TOCS})},
	author = {Chandy, K Mani and Lamport, Leslie},
	date = {1985}
}

@online{mccaffrey_verification_????,
	title = {The Verification of a Distributed System},
	url = {https://queue.acm.org/detail.cfm?id=2889274},
	author = {{McCaffrey}, Caitie}
}

@book{lamport_principles_????,
	title = {Principles and Specifications of Concurrent Systems (Hyperbook)},
	author = {Lamport, Leslie}
}

@inproceedings{garrido_role_2017,
	title = {Role of intermediate nodes in Sparse Network Coding: characterization and practical recoding},
	pages = {1--7},
	booktitle = {European Wireless 2017; 23th European Wireless Conference; Proceedings of},
	publisher = {{VDE}},
	author = {Garrido, Pablo and Lucani, Daniel and Agueero, Ramon},
	date = {2017}
}

@inproceedings{feizi_tunable_2014,
	title = {Tunable sparse network coding for multicast networks},
	doi = {10.1109/NETCOD.2014.6892129},
	abstract = {This paper shows the potential and key enabling mechanisms for tunable sparse network coding, a scheme in which the density of network coded packets varies during a transmission session. At the beginning of a transmission session, sparsely coded packets are transmitted, which benefits decoding complexity. As the transmission continues and the receivers have accumulated coded packets, the coding density is increased. We propose a family of tunable sparse network codes ({TSNCs}) for multicast erasure networks with a controllable trade-off between completion time performance to decoding complexity. Coding density tuning can be performed by designing time-dependent coding matrices. In multicast networks, this tuning can be performed within the network by designing time-dependent pre-coding and network coding matrices with mild conditions on the network structure for specific densities. We present a mechanism to perform efficient Gaussian elimination over sparse matrices going beyond belief propagation but maintaining low decoding complexity. Supporting implementation results are provided showing the trade-off between decoding complexity and completion time.},
	pages = {1--6},
	booktitle = {2014 International Symposium on Network Coding ({NetCod})},
	author = {Feizi, S. and Lucani, D. E. and Sørensen, C. W. and Makhdoumi, A. and Médard, M.},
	date = {2014-06},
	keywords = {multicast communication, Network coding, Decoding, network coding, Encoding, Receivers, belief propagation, coding density tuning, Complexity theory, computational complexity, decoding, decoding complexity, Gaussian elimination, Gaussian processes, multicast erasure networks, network coded packets, network coding matrices, precoding, sparse matrices, Sparse matrices, sparsely coded packets, time-dependent coding matrices, time-dependent precoding matrices, transmission session, {TSNC}, tunable sparse network codes, tunable sparse network coding, tuning, Tuning}
}

@inproceedings{li_network_2012,
	title = {Network coding with unequal size overlapping generations},
	doi = {10.1109/NETCOD.2012.6261902},
	abstract = {In this paper, we focus on content distribution applications with network coding in large networks where the network topology is unknown and no feedback is available. An unequal-size overlapping generation based network coding scheme is proposed. The sizes of generations are drawn from a degree distribution designed by and-or tree analysis. The overlapping of generations introduces redundancy and enables back substitution, which reduces the transmission overhead with little sacrifice of the computational complexity. Comparing with other overlapping based schemes (e.g. head-to-toe, random annex codes), our approach achieves a better overhead-complexity tradeoff.},
	pages = {161--166},
	booktitle = {2012 International Symposium on Network Coding ({NetCod})},
	author = {Li, Y. and Chan, W. Y. and Blostein, S. D.},
	date = {2012-06},
	keywords = {Network coding, network topology, network coding, computational complexity, and-or tree analysis, back substitution, Bismuth, content distribution application, degree distribution, head-to-toe scheme, network coding scheme, overhead-complexity tradeoff, random annex code scheme, transmission overhead, trees (mathematics), unequal-size overlapping generation}
}

@inproceedings{silva_sparse_2009,
	title = {Sparse network coding with overlapping classes},
	pages = {74--79},
	booktitle = {Network Coding, Theory, and Applications, 2009. {NetCod}'09. Workshop on},
	publisher = {{IEEE}},
	author = {Silva, Danilo and Zeng, Weifei and Kschischang, Frank R},
	date = {2009}
}

@article{dimakis_network_2010,
	title = {Network Coding for Distributed Storage Systems},
	volume = {56},
	issn = {0018-9448},
	doi = {10.1109/TIT.2010.2054295},
	abstract = {Distributed storage systems provide reliable access to data through redundancy spread over individually unreliable nodes. Application scenarios include data centers, peer-to-peer storage systems, and storage in wireless networks. Storing data using an erasure code, in fragments spread across nodes, requires less redundancy than simple replication for the same level of reliability. However, since fragments must be periodically replaced as nodes fail, a key question is how to generate encoded fragments in a distributed way while transferring as little data as possible across the network. For an erasure coded system, a common practice to repair from a single node failure is for a new node to reconstruct the whole encoded data object to generate just one encoded block. We show that this procedure is sub-optimal. We introduce the notion of regenerating codes, which allow a new node to communicate functions of the stored data from the surviving nodes. We show that regenerating codes can significantly reduce the repair bandwidth. Further, we show that there is a fundamental tradeoff between storage and repair bandwidth which we theoretically characterize using flow arguments on an appropriately constructed graph. By invoking constructive results in network coding, we introduce regenerating codes that can achieve any point in this optimal tradeoff.},
	pages = {4539--4551},
	number = {9},
	journaltitle = {{IEEE} Transactions on Information Theory},
	author = {Dimakis, A. G. and Godfrey, P. B. and Wu, Y. and Wainwright, M. J. and Ramchandran, K.},
	date = {2010-09},
	keywords = {Network coding, Computer science, network coding, Peer to peer computing, Bandwidth, Communication system control, data centers, Distributed storage, distributed storage systems, encoded fragments, erasure coded system, error correction codes, peer-to-peer storage, peer-to-peer storage systems, Redundancy, regenerating codes, repair bandwidth, Statistics, storage area networks, Telecommunication network reliability, wireless networks, Wireless networks}
}

@article{hanada_asynchronous_2017,
	title = {An Asynchronous Gossip Algorithm with Restart Strategy in Distributed Minimax Optimization**This research was supported by {CREST}, Japan Science and Technology Agency.},
	volume = {50},
	issn = {2405-8963},
	url = {http://www.sciencedirect.com/science/article/pii/S2405896317327520},
	doi = {https://doi.org/10.1016/j.ifacol.2017.08.2092},
	abstract = {An asynchronous gossip algorithm with a restart strategy is proposed to an approximated distributed minimax optimization in this paper. The restart strategy controls a step length of a subgradient method and resets a local clock under a certain criteria in the algorithm. The convergence property is analyzed for the algorithm with the restart strategy. Numerical examples illustrate that the proposed algorithm works well in various instances and high approximation ratios.},
	pages = {14212 -- 14217},
	number = {1},
	journaltitle = {{IFAC}-{PapersOnLine}},
	author = {Hanada, Kenta and Wada, Takayuki and Fujisaki, Yasumasa},
	date = {2017},
	keywords = {Asynchronous gossip algorithms, Distributed algorithms, Minimax optimization, Restart strategy, Subgradient method}
}

@article{corbett_spanner:_2013,
	title = {Spanner: Google’s globally distributed database},
	volume = {31},
	pages = {8},
	number = {3},
	journaltitle = {{ACM} Transactions on Computer Systems ({TOCS})},
	author = {Corbett, James C and Dean, Jeffrey and Epstein, Michael and Fikes, Andrew and Frost, Christopher and Furman, Jeffrey John and Ghemawat, Sanjay and Gubarev, Andrey and Heiser, Christopher and Hochschild, Peter and {others}},
	date = {2013}
}

@article{yen_resetting_1997,
	title = {Resetting vector clocks in distributed systems},
	volume = {43},
	pages = {15--20},
	number = {1},
	journaltitle = {Journal of Parallel and Distributed Computing},
	author = {Yen, Li-Hsing and Huang, Ting-Lu},
	date = {1997}
}

@inproceedings{escriva_kronos:_2014,
	location = {New York, {NY}, {USA}},
	title = {Kronos: The Design and Implementation of an Event Ordering Service},
	isbn = {978-1-4503-2704-6},
	url = {http://doi.acm.org/10.1145/2592798.2592822},
	doi = {10.1145/2592798.2592822},
	series = {{EuroSys} '14},
	pages = {3:1--3:14},
	booktitle = {Proceedings of the Ninth European Conference on Computer Systems},
	publisher = {{ACM}},
	author = {Escriva, Robert and Dubey, Ayush and Wong, Bernard and Sirer, Emin Gün},
	date = {2014}
}

@inproceedings{charapko_retrospective_2017,
	title = {Retrospective Lightweight Distributed Snapshots Using Loosely Synchronized Clocks},
	doi = {10.1109/ICDCS.2017.273},
	abstract = {In order to take a consistent snapshot of a distributed system, it is necessary to collate and align local logs from each node to construct a pairwise concurrent cut. By leveraging {NTP} synchronized clocks, and augmenting them with logical clock causality information, Retroscope provides a lightweight solution for taking unplanned retrospective snapshots of past distributed system states. Instead of storing a multiversion copy of the entire system data, this is achieved efficiently by maintaining a configurable-size sliding window-log at each node to capture recent operations. In addition to retrospective snapshots, Retroscope also provides incremental and rolling snapshots that utilize an existing snapshot to reduce the cost of constructing a new snapshot in proximity. This capability is useful for performing stepwise debugging and root-cause analysis, and supporting data integrity monitoring and checkpoint-recovery. We implement Retroscope for the Voldemort distributed datastore and evaluate its performance under varying workloads.},
	pages = {2061--2066},
	booktitle = {2017 {IEEE} 37th International Conference on Distributed Computing Systems ({ICDCS})},
	author = {Charapko, A. and Ailijiang, A. and Demirbas, M. and Kulkarni, S.},
	date = {2017-06},
	keywords = {Electronic mail, checkpoint-recovery, Clocks, configurable-size sliding window-log, data-integrity monitoring, Databases, Debugging, distributed databases, distributed processing, distributed system states, incremental snapshots, Libraries, local logs, logical clock causality information, loosely synchronized clocks, Monitoring, {NTP} synchronized clocks, program debugging, retroscope distributed datastore, retrospective lightweight distributed snapshots, rolling snapshots, root-cause analysis, stepwise debugging, Synchronization, unplanned retrospective snapshots, Voldemort distributed datastore}
}

@article{demirbas_logical_2014,
	title = {Logical Physical Clocks and Consistent Snapshots in Globally Distributed Databases},
	author = {Demirbas, Murat and Leone, Marcelo and Avva, Bharadwaj and Madeppa, Deepak and Kulkarni, Sandeep},
	date = {2014}
}

@online{_android_????,
	title = {Android {OS} - Processes and the Zygote!},
	url = {http://coltf.blogspot.fr/p/android-os-processes-and-zygote.html},
	titleaddon = {Colt's Blog},
	urldate = {2018-02-09}
}

@online{_copperheados:_????,
	title = {{CopperheadOS}: Securing the Android},
	url = {https://lwn.net/Articles/675719/}
}

@inproceedings{grandl_altruistic_2016,
	location = {Savannah, {GA}},
	title = {Altruistic Scheduling in Multi-Resource Clusters},
	isbn = {978-1-931971-33-1},
	url = {https://www.usenix.org/conference/osdi16/technical-sessions/presentation/grandl_altruistic},
	pages = {65--80},
	booktitle = {12th {USENIX} Symposium on Operating Systems Design and Implementation ({OSDI} 16)},
	publisher = {{USENIX} Association},
	author = {Grandl, Robert and Chowdhury, Mosharaf and Akella, Aditya and Ananthanarayanan, Ganesh},
	date = {2016}
}

@inproceedings{grandl_graphene:_2016,
	location = {Savannah, {GA}},
	title = {{GRAPHENE}: Packing and Dependency-Aware Scheduling for Data-Parallel Clusters},
	isbn = {978-1-931971-33-1},
	url = {https://www.usenix.org/conference/osdi16/technical-sessions/presentation/grandl_graphene},
	pages = {81--97},
	booktitle = {12th {USENIX} Symposium on Operating Systems Design and Implementation ({OSDI} 16)},
	publisher = {{USENIX} Association},
	author = {Grandl, Robert and Kandula, Srikanth and Rao, Sriram and Akella, Aditya and Kulkarni, Janardhan},
	date = {2016}
}

@inproceedings{gilad_algorand:_2017,
	location = {New York, {NY}, {USA}},
	title = {Algorand: Scaling Byzantine Agreements for Cryptocurrencies},
	isbn = {978-1-4503-5085-3},
	url = {http://doi.acm.org/10.1145/3132747.3132757},
	doi = {10.1145/3132747.3132757},
	series = {{SOSP} '17},
	pages = {51--68},
	booktitle = {Proceedings of the 26th Symposium on Operating Systems Principles},
	publisher = {{ACM}},
	author = {Gilad, Yossi and Hemo, Rotem and Micali, Silvio and Vlachos, Georgios and Zeldovich, Nickolai},
	date = {2017}
}

@inproceedings{cui_paxos_2015,
	location = {New York, {NY}, {USA}},
	title = {Paxos Made Transparent},
	isbn = {978-1-4503-3834-9},
	url = {http://doi.acm.org/10.1145/2815400.2815427},
	doi = {10.1145/2815400.2815427},
	series = {{SOSP} '15},
	pages = {105--120},
	booktitle = {Proceedings of the 25th Symposium on Operating Systems Principles},
	publisher = {{ACM}},
	author = {Cui, Heming and Gu, Rui and Liu, Cheng and Chen, Tianyu and Yang, Junfeng},
	date = {2015},
	keywords = {fault tolerance, software reliability, stable and deterministic multithreading, state machine replication}
}

@inproceedings{decouchant_pag:_2016,
	title = {{PAG}: Private and Accountable Gossip},
	url = {https://doi.org/10.1109/ICDCS.2016.34},
	doi = {10.1109/ICDCS.2016.34},
	pages = {35--44},
	booktitle = {36th {IEEE} International Conference on Distributed Computing Systems, {ICDCS} 2016, Nara, Japan, June 27-30, 2016},
	author = {Decouchant, Jeremie and Mokhtar, Sonia Ben and Petit, Albin and Quéma, Vivien},
	date = {2016}
}

@inproceedings{berthou_fastcast:_2013,
	title = {{FastCast}: A Throughput- and Latency-Efficient Total Order Broadcast Protocol},
	url = {https://doi.org/10.1007/978-3-642-45065-5_1},
	doi = {10.1007/978-3-642-45065-5_1},
	pages = {1--20},
	booktitle = {Middleware 2013 - {ACM}/{IFIP}/{USENIX} 14th International Middleware Conference, Beijing, China, December 9-13, 2013, Proceedings},
	author = {Berthou, Gautier and Quéma, Vivien},
	date = {2013}
}

@inproceedings{guerraoui_atum:_2016,
	title = {Atum: Scalable Group Communication Using Volatile Groups},
	url = {http://dl.acm.org/citation.cfm?id=2988356},
	pages = {19},
	booktitle = {Proceedings of the 17th International Middleware Conference, Trento, Italy, December 12 - 16, 2016},
	author = {Guerraoui, Rachid and Kermarrec, Anne-Marie and Pavlovic, Matej and Seredinschi, Dragos-Adrian},
	date = {2016}
}

@article{eugster_lightweight_2003,
	title = {Lightweight Probabilistic Broadcast},
	volume = {21},
	issn = {0734-2071},
	url = {http://doi.acm.org/10.1145/945506.945507},
	doi = {10.1145/945506.945507},
	pages = {341--374},
	number = {4},
	journaltitle = {{ACM} Trans. Comput. Syst.},
	author = {Eugster, P. Th. and Guerraoui, R. and Handurukande, S. B. and Kouznetsov, P. and Kermarrec, A.-M.},
	date = {2003-11},
	keywords = {gossip, Broadcast, buffering, garbage collection, noise, randomization, reliability, scalability}
}

@article{kermarrec_probabilistic_2003,
	title = {Probabilistic reliable dissemination in large-scale systems},
	volume = {14},
	issn = {1045-9219},
	doi = {10.1109/TPDS.2003.1189583},
	abstract = {The growth of the Internet raises new challenges for the design of distributed systems and applications. In the context of group communication protocols, gossip-based schemes have attracted interest as they are scalable, easy to deploy, and resilient to network and process failures. However, traditional gossip-based protocols have two major drawbacks: 1) they rely on each peer having knowledge of the global membership; and 2) being oblivious to the network topology, they can impose a high load on network links when applied to wide-area settings. In this paper, we provide a theoretical analysis of gossip-based protocols which relates their reliability to key system parameters (the system size, failure rates, and number of gossip targets). The results provide guidelines for the design of practical protocols. In particular, they show how reliability can be maintained while alleviating drawback by: 1) providing each peer with only a small subset of the total membership information and drawback; and 2) organizing members into a hierarchical structure that reflects their proximity according to some network-related metric. We validate the analytical results by simulations and verify that the hierarchical gossip protocol considerably reduces the load on the network compared to the original, non-hierarchical protocol.},
	pages = {248--258},
	number = {3},
	journaltitle = {{IEEE} Transactions on Parallel and Distributed Systems},
	author = {Kermarrec, A. M. and Massoulie, L. and Ganesh, A. J.},
	date = {2003-03},
	keywords = {Context, Network topology, graph theory, group communication, Telecommunication network reliability, distributed processing, reliability, scalability, distributed systems, Failure analysis, gossip-based protocols, groupware, Guidelines, Internet, large-scale systems, Large-scale systems, Maintenance, membership information, multicast protocols, probabilistic multicast, Protocols, random graphs, Reliability theory}
}

@article{mercier_optimal_2017,
	title = {Optimal epidemic dissemination},
	journaltitle = {{arXiv} preprint {arXiv}:1709.00198},
	author = {Mercier, Hugues and Hayez, Laurent and Matos, Miguel},
	date = {2017}
}

@inproceedings{koldehofe_buffer_2003,
	title = {Buffer management in probabilistic peer-to-peer communication protocols},
	pages = {76--85},
	booktitle = {Reliable Distributed Systems, 2003. Proceedings. 22nd International Symposium on},
	publisher = {{IEEE}},
	author = {Koldehofe, Boris},
	date = {2003}
}

@article{alvisi_how_2007,
	title = {How robust are gossip-based communication protocols?},
	volume = {41},
	pages = {14--18},
	number = {5},
	journaltitle = {{ACM} {SIGOPS} Operating Systems Review},
	author = {Alvisi, Lorenzo and Doumen, Jeroen and Guerraoui, Rachid and Koldehofe, Boris and Li, Harry and Van Renesse, Robbert and Tredan, Gilles},
	date = {2007}
}

@article{fernandess_generic_2007,
	title = {A generic theoretical framework for modeling gossip-based algorithms},
	volume = {41},
	pages = {19--27},
	number = {5},
	journaltitle = {{ACM} {SIGOPS} Operating Systems Review},
	author = {Fernandess, Yaacov and Fernández, Antonio and Monod, Maxime},
	date = {2007}
}

@article{chen_buffer-aware_2012,
	title = {Buffer-aware network coding for wireless networks},
	volume = {20},
	pages = {1389--1401},
	number = {5},
	journaltitle = {{IEEE}/{ACM} Transactions on Networking ({TON})},
	author = {Chen, Wei and Letaief, Khaled B and Cao, Zhigang},
	date = {2012}
}

@article{euster_epidemics_2004,
	title = {From epidemics to distributed computing},
	volume = {37},
	pages = {60--67},
	number = {5},
	journaltitle = {{IEEE} Computer},
	author = {Euster, Patrick and Guerraoui, Rachid and Kermarrec, Anne-Marie and Maussoulie, Laurent},
	date = {2004}
}

@article{pittel_spreading_1987,
	title = {On Spreading a Rumor},
	volume = {47},
	url = {https://doi.org/10.1137/0147013},
	doi = {10.1137/0147013},
	pages = {213--223},
	number = {1},
	journaltitle = {{SIAM} Journal on Applied Mathematics},
	author = {Pittel, Boris},
	date = {1987}
}

@article{koldehofe_simple_2004,
	title = {Simple gossiping with balls and bins.},
	volume = {3},
	pages = {43--60},
	number = {1},
	journaltitle = {Stud. Inform. Univ.},
	author = {Koldehofe, Boris},
	date = {2004}
}

@inproceedings{frey_boosting_2010,
	title = {Boosting Gossip for Live Streaming},
	doi = {10.1109/P2P.2010.5569962},
	abstract = {Gossip protocols are considered very effective to disseminate information in a large scale dynamic distributed system. Their inherent simplicity makes them easy to implement and deploy. However, whereas their probabilistic guarantees are often enough to disseminate data in the context of low- bandwidth applications, they typically do not suffice for high-bandwidth content dissemination: missing 1\% is unacceptable for live streaming. In this paper, we show how the combination of two simple mechanisms copes with this seemingly inherent deficiency of gossip: (i) codec, an erasure coding scheme, and (ii) claim2, a content- request scheme that leverages gossip duplication to diversify the retransmission sources of missing information. We show how these mechanisms can effectively complement each other in a new gossip protocol, gossip++, which retains the simplicity of deployment of plain gossip. In a realistic setting with an average bandwidth capability (800 kbps) close to the stream rate (680 kbps) and 1\% message loss, plain gossip can provide at most 99\% of the stream. Using gossip++, on the other hand, all nodes can view a perfectly clear stream.},
	pages = {1--10},
	booktitle = {2010 {IEEE} Tenth International Conference on Peer-to-Peer Computing (P2P)},
	author = {Frey, D. and Guerraoui, R. and Kermarrec, A. M. and Monod, M.},
	date = {2010-08},
	keywords = {Encoding, Peer to peer computing, Bandwidth, Protocols, Codecs, content- request scheme, encoding, erasure coding scheme, Forward error correction, gossip boosting, gossip protocols, gossip++, information dissemination, live streaming, protocols, replicated databases, Streaming media, video streaming}
}

@inproceedings{fountoulakis_ultra-fast_2012,
	location = {Philadelphia, {PA}, {USA}},
	title = {Ultra-fast Rumor Spreading in Social Networks},
	url = {http://dl.acm.org/citation.cfm?id=2095116.2095246},
	series = {{SODA} '12},
	pages = {1642--1660},
	booktitle = {Proceedings of the Twenty-third Annual {ACM}-{SIAM} Symposium on Discrete Algorithms},
	publisher = {Society for Industrial and Applied Mathematics},
	author = {Fountoulakis, Nikolaos and Panagiotou, Konstantinos and Sauerwald, Thomas},
	date = {2012}
}